// pages/apply/paymentTemplate/add/add.js
import * as UTIL from '../../../../utils/util.js';
import * as API from '../../../../utils/API.js';
let EVN_CONFIG = require('../../../../env/env');
const DISTRIBUTE_ENVIROMENT = 'IMGURL';
let {
    URL_PREFIX,
} = EVN_CONFIG[DISTRIBUTE_ENVIROMENT];
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isIPX: app.globalData.isIPX,
    radio:'1',
    active:0,
    projectText:'',
    balance:0,
    showCapitalExpenditureType:false,
    showApplyDate:false,
    showTransferType:false,
    showProject:false,
    showProjectFundType:false,
    showAccount:false,
    showDialog:false,
    capitalExpenditureTypeOptions:[],
    transferTypeOptions:[],
    projectOptions:[],
    projectFundTypeOptions:[],
    contractionOptions:[],
    accountOptions:[],
    moneyorderOptions:[],
    form:{
      approvalItemTemplate:{
        approvalItems:'',//审批事项
        submitCompany:'',//提交单位
        submitDate:'',//提交日期
        submitter:'',//提交人
        telephone:'',//联系方式
        totalAmount:'',//合计金额
        templateName:'',//模板名称 选择保存模板的时候添加
        dataType:'',//数据类型
      },
      transfers:[{//事项信息集合以下是List对象信息
        num:"一",
        capitalExpenditureType:'',//资金支出类别
        capitalExpenditureTypeText:'',//资金支出类别（展示用）
        succeedAmount:'',//成功支付金额
        payer:'',//付款方
        payerAccount:'',//付款方账户
        bankType:'',//所属银行
        bankTypeText:'',//所属银行（展示用）
        isPeers:'',//是否同行
        operatorCode:'',//操作员代码
        enterpriseCode:'',//企业编码
        expenditureAmount:'',//支出总金额
        applyDate:'',//申请时间
        transferStatus:'',//转账状态
        auditStatus:'',//审批状态
        paymentState:'',//支付状态
        approvalMode:'',//审批模式
        paymentTime:'',//支付时间
        bankPriority:'',//银行处理优先级
        clientPriority:'',//客户处理优先级
        transferType:'',//付款方式
        transferTypeText:'',//付款方式（展示用）
        requiredTransferTime:'',//要求转账时间
        remark:'',//付款事由
        startTime:'',//开票日期
        endTime:'',//到期日期
        orderType:'',//汇票类型
        bankAccountType:'',//账户类别1 公户2私户
        villageAccountType:'',//账户分类
        payeeList:[{//收款方账户集合
          payeeId:'0',//收款方id
          payee:'',//收款方
          bankDeposit:'',//开户行
          incomeAmount:'',//收入金额
          bankType:'',//所属银行0其他银行1中国银行2农商行（山东省）3农业银行4建设银行5工商银行
          payeeAccount:'',//收款账户
        }],
      }],
    },
    projectForm:{
      projectId:'',
      projectName:'',
      projectContractor:'',
      projectAmount:'',
      projectBillNum:'',
      projectFundType:'',
      outId:'',
      ynType:'1',
    },
    contractionForm:{
      id:'',
      name:'',
      code:'',
      totalAmount:'',
    },
    accountForm:{},
    fileForm:[]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    var that = this;
    setTimeout(function(){
      UTIL.httpRequest(API.URL_GET_USERAPPRO, {method:'GET'}, {
        success: (res) => {
          if (res.code == API.SUCCESS_CODE) {
            console.log(that.data.capitalExpenditureTypeOptions);
            res.data.transfers.forEach( (item,index) => {
              res.data.transfers[index].capitalExpenditureTypeText = UTIL.getTransform(item.capitalExpenditureType,that.data.capitalExpenditureTypeOptions);
              res.data.transfers[index].transferTypeText = UTIL.getTransform(item.transferType,that.data.transferTypeOptions);
  
              res.data.transfers[index].bankTypeText = UTIL.getTransform(item.bankType,that.data.bankTypeOptions);
  
              res.data.transfers[index].payeeList.forEach( (response,i) => {
                res.data.transfers[index].payeeList[i].bankTypeText = UTIL.getTransform(response.bankType,that.data.bankTypeOptions);
              })
            })
            that.setData({
              form:res.data
            })
            //收据附件
            UTIL.httpRequest(
              API.URL_GET_FINDLIST, 
              {
                method:'GET',
                tableName:'t_yinnong_approval_item_template',
                tableId:res.data.approvalItemTemplate.id,
                fileType:1
              }, 
              {
              success: (res) => {
                let list = [];
                res.data.forEach(item=>{
                  list.push({
                    tempFilePath:URL_PREFIX+item.fileUrl
                  })
                })
                that.setData({
                  SJimage:list
                });
              }
            })
            //发票
            UTIL.httpRequest(
              API.URL_GET_FINDLIST, 
              {
                method:'GET',
                tableName:'t_yinnong_approval_item_template',
                tableId:res.data.approvalItemTemplate.id,
                fileType:2
              }, 
              {
              success: (res) => {
                let list = [];
                res.data.forEach(item=>{
                  list.push({
                    tempFilePath:URL_PREFIX+item.fileUrl
                  })
                })
                that.setData({
                  FPimage:list
                });
              }
            })
            //其他
            UTIL.httpRequest(
              API.URL_GET_FINDLIST, 
              {
                method:'GET',
                tableName:'t_yinnong_approval_item_template',
                tableId:res.data.approvalItemTemplate.id,
                fileType:3
              }, 
              {
              success: (res) => {
                let list = [];
                res.data.forEach(item=>{
                  list.push({
                    tempFilePath:URL_PREFIX+item.fileUrl
                  })
                })
                that.setData({
                  QTimage:list
                });
              }
            })

          }
        }
      })
    },1000)
    
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    var that = this;

    UTIL.httpRequest(API.URL_GET_GETINFO, {method:'GET'}, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          that.setData({
            ["form.approvalItemTemplate.submitCompany"]:res.user.bookName,
            ["form.approvalItemTemplate.submitDate"]:UTIL.js_date_time(new Date()),
            ["form.approvalItemTemplate.submitter"]:res.user.nickName,
            ["form.approvalItemTemplate.telephone"]:res.user.phonenumber,
          })

        }
      }
    })
    //所属银行
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'bank_type', {method:'GET'}, {
      success: (res) => {
        this.setData({
          bankTypeOptions:res.data
        });
      }
    })
    // 资金支出类别字典查询
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'capital_expenditure_type', {method:'GET'}, {
      success: (res) => {
        that.setData({
          capitalExpenditureTypeOptions:res.data,
        })
      }
    })
    // 付款方式类型字典查询 
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'transfer_type', {method:'GET'}, {
      success: (res) => {
        that.setData({
          transferTypeOptions:res.data,
        })
      }
    })
    // 项目工程列表 
    UTIL.httpRequest(API.URL_GET_GETPROJECTLIST , {method:'GET'}, {
      success: (res) => {
        that.setData({
          projectOptions:res.rows,
        })
      }
    })
    // 工程款类型字典查询 
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'project_fund_type', {method:'GET'}, {
      success: (res) => {
        that.setData({
          projectFundTypeOptions:res.data,
        })
      }
    })
    // 获取合同信息列表
    UTIL.httpRequest(API.URL_GET_CONTRACTIONLIST , {method:'GET'}, {
      success: (res) => {
        that.setData({
          contractionOptions:res.rows,
        })
      }
    })
    
  },
  openBox(even){
    this.setData({
      [even.currentTarget.dataset.name]:true
    })
  },
  closeBox(even){
    console.log(even.currentTarget.dataset.name);
    this.setData({
      [even.currentTarget.dataset.name]:false
    })
  },
  onConfirm(event) {
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: UTIL.formatDate(event.detail),
    });
  },
  onConfirmPick(event) {
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: event.detail.value.dictValue,
      [event.currentTarget.dataset.value+'Text']: event.detail.value.dictLabel,
    });
  },
  onConfirmAccount(event) {
    console.log(event);
    var that = this;
    // 所属银行字典查询 
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'bank_type', {method:'GET'}, {
      success: (res) => {
        let array = res.data.filter(function (e) { return e.dictValue == event.detail.value.bankType; });
        this.setData({
          [event.currentTarget.dataset.name]: false,
          [event.currentTarget.dataset.value+'.payer']: event.detail.value.accountName,
          [event.currentTarget.dataset.value+'.cashierId']: event.detail.value.id,
          [event.currentTarget.dataset.value+'.payerAccount']: event.detail.value.bankAccountNumber,
          [event.currentTarget.dataset.value+'.bankTypeText']: array[0].dictLabel,
          [event.currentTarget.dataset.value+'.bankType']: event.detail.value.bankType,
          balance:event.detail.value.balance,
        });
      }
    })
  },
  onConfirmaTransfer(event) {
    console.log(event);
    var that = this;
    let perames = {};
    this.setData({
      [event.currentTarget.dataset.value+'.payer']: '',
      [event.currentTarget.dataset.value+'.payerAccount']: '',
      [event.currentTarget.dataset.value+'.bankTypeText']: '',
      [event.currentTarget.dataset.value+'.bankType']: '',
      [event.currentTarget.dataset.value+'.bankAccountType']: '',  
      [event.currentTarget.dataset.value+'.isPeers']: '',  
      balance:0,
    });
    if(event.detail.value.dictValue == 1){//村账户查询参数
      perames = {
        pageNum:1,
        pageSize:999,
        accountType:'102',
        method:'post',
        params: {
          "townAccountType":"0"
        }
      }
      // 付款方列表
      UTIL.httpRequest(API.URL_GET_SELECTACCOUNTLIST , perames, {
        success: (res) => {
          that.setData({
            accountOptions:res.rows,
          })
        }
      })
    }
    if(event.detail.value.dictValue == 2 || event.detail.value.dictValue == 10){//公务卡和现金提现查询参数
      perames = {
        pageNum:1,
        pageSize:999,
        accountType:'102',
        method:'GET',
        villageAccountType:''
      }
      // 付款方列表
      UTIL.httpRequest(API.URL_GET_ACCOUNTLIST , perames, {
        success: (res) => {
          that.setData({
            accountOptions:res.rows,
          })
        }
      })
    }
    if(event.detail.value.dictValue == 11){//现金使用查询参数
      perames = {
        pageNum:1,
        pageSize:999,
        accountType:'101',
        method:'GET'
      }
      // 付款方列表
      UTIL.httpRequest(API.URL_GET_ACCOUNTLIST , perames, {
        success: (res) => {
          that.setData({
            accountOptions:res.rows
          })
        }
      })
    }
    if(event.detail.value.dictValue == 4){//代管账户查询参数
      perames = {
        pageNum:1,
        pageSize:999,
        accountType:'102',
        method:'GET',
        villageAccountType:'1'
      }
      // 付款方列表
      UTIL.httpRequest(API.URL_GET_ACCOUNTLIST , perames, {
        success: (res) => {
          that.setData({
            accountOptions:res.rows,
          })
        }
      })
    }
    if(event.detail.value.dictValue == 12){//汇票支出查询参数
      perames = {
        pageNum:1,
        pageSize:999,
      }
      // 付款方列表
      UTIL.httpRequest(API.URL_GET_MONEYORDERLIST , perames, {
        success: (res) => {
          that.setData({
            moneyorderOptions:res.rows,
          })
        }
      })
    }
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value+'.transferType']: event.detail.value.dictValue,
      [event.currentTarget.dataset.value+'.transferTypeText']: event.detail.value.dictLabel,
    });
  },
  onConfirmProject(event) {
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: event.detail.value.projectName,
      ['projectForm.projectId']: event.detail.value.id,
      ['projectForm.projectContractor']: event.detail.value.projectContractor,
      ['projectForm.projectAmount']: event.detail.value.projectAmount,
    });
  },
  onConfirmContraction(event) {
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: event.detail.value.name,
      ['contractionForm.code']: event.detail.value.code,
      ['contractionForm.totalAmount']: event.detail.value.totalAmount,
      ['contractionForm.id']: event.detail.value.id,
    });
  },
  onConfirmMoneyorder(event) {
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: event.detail.value.name,
      ['contractionForm.code']: event.detail.value.code,
      ['contractionForm.totalAmount']: event.detail.value.totalAmount,
      ['contractionForm.id']: event.detail.value.id,
    });
  },
  goPayeeList(event){
    console.log(event);
    wx.navigateTo({
      url: '/pages/payee/index?isPeers='+event.currentTarget.dataset.ispeers+'&bankType='+event.currentTarget.dataset.banktype+'&accountType='+event.currentTarget.dataset.accounttype+'&transferType='+event.currentTarget.dataset.transfertype,
    })
  },
  onChange(event){
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.value]: event.detail,
    })
  },
  onChangeMoney(event){
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.value]: event.detail,
      ["form.approvalItemTemplate.totalAmount"]:event.detail,
      ["form.transfers[0].expenditureAmount"]:event.detail,
    })
  },
  back:function(){
    wx.navigateBack({
      delta: 1
    })
  },
  goSubmitMB(){
    this.setData({
      showDialog:true
    })
  },
  onClose(){
    this.setData({
      showDialog:false
    })
  },
  bindNameInput(even){
    this.setData({
      ["form.approvalItemTemplate.templateName"]:even.detail.value
    })
  },
  goSubmit(e){
    var that = this;
    if(e.currentTarget.dataset.type == 1){
      if(that.data.form.approvalItemTemplate.templateName == ''){
        UTIL.showToastNoneIcon('请输入模板名称！');
        return;
      }
    }
    that.setData({
      ['form.method']:'POST',
      ["form.approvalItemTemplate.dataType"]:e.currentTarget.dataset.type
    })
    UTIL.httpRequest(API.URL_GET_SAVE, that.data.form, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          for (let i = 0; i < that.data.fileForm.length; i++) {
            that.data.fileForm[i].tableId = res.data.id
            const element = that.data.fileForm[i];
            wx.uploadFile({
              url: API.URL_GET_UPLOAD,
              filePath: element.file,
              name: 'file',
              header: {
                "Content-Type": "multipart/form-data",//记得设置
                "chartset":"utf-8",
                'Authorization':'Bearer '+getApp().globalData.userInfo.token
              },
              formData:element,
              success (response){
                console.log(res);
                if((i+1) == that.data.fileForm.length){
                  wx.navigateTo({
                    url: '/pages/apply/approval/approval?id='+res.data.id,
                  })
                }
              },
              fail(res){
                console.log(res)
              }
            })
          }
        }
      }
    })
  },
  bindKeyInput(even){
    this.setData({
      ["form.approvalItemTemplate.approvalItems"]: even.detail.value,
    })
  },
  SJtakephoto(){
    var that = this;
    let fileForm = that.data.fileForm;
    wx.chooseMedia({
      count: 9,
      mediaType: ['image','video'],
      sourceType: ['album', 'camera'],
      maxDuration: 30,
      camera: 'back',
      success(res) {
        console.log(res);
        res.tempFiles.forEach(item => {
          fileForm.push({
            file: item.tempFilePath,
            fileType:'1',
            bizPath:'transfer',
            tableName:'t_yinnong_approval_item_template',
            tableId:''
          })
        })
        that.setData({
          SJimage:res.tempFiles,
          fileForm:fileForm
        })
      }
    })
  },
  FPtakephoto(){
    var that = this;
    let fileForm = that.data.fileForm;
    wx.chooseMedia({
      count: 9,
      mediaType: ['image','video'],
      sourceType: ['album', 'camera'],
      maxDuration: 30,
      camera: 'back',
      success(res) {
        res.tempFiles.forEach(item => {
          fileForm.push({
            file: item.tempFilePath,
            fileType:'2',
            bizPath:'transfer',
            tableName:'t_yinnong_approval_item_template',
            tableId:''
          })
        })
        that.setData({
          FPimage:res.tempFiles,
          fileForm:fileForm
        })
      }
    })
  },
  QTtakephoto(){
    var that = this;
    let fileForm = that.data.fileForm;
    wx.chooseMedia({
      count: 9,
      mediaType: ['image','video'],
      sourceType: ['album', 'camera'],
      maxDuration: 30,
      camera: 'back',
      success(res) {
        res.tempFiles.forEach(item => {
          fileForm.push({
            file: item.tempFilePath,
            fileType:'3',
            bizPath:'transfer',
            tableName:'t_yinnong_approval_item_template',
            tableId:''
          })
        })
        that.setData({
          QTimage:res.tempFiles,
          fileForm:fileForm
        })
      }
    })
  },
  addList(){
    let transList = this.data.form.transfers;
    transList.push({
      num:UTIL.convertToChinaNum(transList.length+1)
    });
    this.setData({
      ["form.transfers"] : transList
    })
  },
  openPreview(e){
    let array = [];
    console.log(e);
    e.currentTarget.dataset.option.forEach(item=>{
      array.push(item.tempFilePath)
    })
    console.log(array);
    wx.previewImage({
      urls: array,
      showmenu:true,
      current:array[e.currentTarget.dataset.index]
    })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})